<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: applet/TDIApplet.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: applet/TDIApplet.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * @license
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2014 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

define(['underscore', 'jquery', 'uweaver/lang',
    'uweaver/widget/Widget', 'uweaver/widget/TabPanel', 'uweaver/applet/Gadget',
    'uweaver/Logger',
    'uweaver/exception/UnsupportedTypeException'], function (_, $, lang, Widget, TabPanel, Gadget, Logger,  UnsupportedTypeException) {

    var declare = lang.declare;
    var Base = Widget;
    var LOGGER = new Logger("uweaver/applet/TDIApplet");

    /**
     * An applet is an application for one specific activity.
     *
     * ##### Usage
     *     var applet = new TDIApplet({
     *         el: $('#applet')
     *     });
     *     applet.render();
     *
     *     var messages = new Gadget({
     *         tpl: "&lt;h3>Messages&lt;/h3>&lt;p>Here are messages for you ...&lt;/p>"
     *         title: "Messages",
     *         badge: "3"
     *     }).render();
     *
     *     applet.add(messages);
     *
     * ##### Events:
     * + 'select' - [select()]{@link TDIApplet#select}, [add()]{@link TDIApplet#add}, [remove()]{@link TDIApplet#remove}
     * + 'selected' - [select()]{@link TDIApplet#select}, [add()]{@link TDIApplet#add}, [remove()]{@link TDIApplet#remove}
     * + 'add' - [add()]{@link TDIApplet#add}
     * + 'remove' - [remove()]{@link TDIApplet#remove}
     * + 'transition:menu' - [menu()]{@link TDIApplet#menu}, [title()]{@link TDIApplet#title}
     *
     * @constructor TDIApplet
     * @extends Widget
     * @author  Jason Lin
     * @since   1.0
     * @param {Object} [config] - The configuration of the applet.
     * @param {String} [config.tpl] - A html string to layout &amp; construct the DOM.
     * @param {String} [config.title] - The title of the applet.
     */
    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);

        var defaults = {};
        var cfg = this._cfg;

        _.defaults(cfg, defaults);

        this._title = cfg.title;
    }

    /**
     * @override
     */
    function render(options) {
        Base.prototype.render.apply(this, arguments);

        var defaults = {
            hidden: false
        };
        var cfg = this._cfg;

        options || (options = {});
        _.defaults(options, defaults);

        this.hide();

        var anchors = this._anchors;

        var tabPanel = new TabPanel().render();

        tabPanel.attach(this.$el);
        this.listenTo(tabPanel, 'all', _.bind(onTabPanelActions, this));

        this._tabPanel = tabPanel;

        if(this.render === render) {
            this._isRendered = true;

            this.trigger('rendered', {
                data: {},
                context: this,
                source: this
            });
            options.hidden || this.show();
        }

        return this;
    }

    function onTabPanelActions(type, e) {
        var interested = ["add", "select", "change", "remove"];

        if(!_.contains(interested, type)) return;

        var event = {
            context: this,
            source: e.context,
            data: e.data
        };

        this.trigger(type, event);
    }

    function isSingleton() {
        return this._singleton;
    }

    function start() {
        this.render();

        var event = {
            data: {},
            context: this,
            source: this
        };
        this.trigger('started', event);
    }

    function stop() {
        var event = {
            data: {},
            context: this,
            source: this
        };
        this.trigger('stop', event);
        this.destroy();
    }

    function pid() {
        return this.oid();
    }

    /**
     * Get or set the title of the applet.
     *
     * ##### Events:
     * - 'transition:title' => triggered after title changed.
     *
     * @memberof TDIApplet#
     * @param {Object} [text] - the title.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {String}
     */
    function title(text, options) {
        if(!text) return this._title;

        this._title = text;

        options || (options = {});

        options.silent || this.trigger('transition', {
            context: this,
            source: this,
            data: undefined
        });
    }

    /**
     *
     * Get or set the menu.
     *
     * ##### Events:
     * - 'transition:menu' => triggered after menu changed. event.data => the menu.
     *
     * @memberof TDIApplet#
     * @param {Triggers} triggers - the menu.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {Triggers}
     *
     */
    function menu(triggers, options) {
        if(!triggers) return this._menu;

        options || (options = {});

        this._menu = triggers;
        options.silent || this.trigger('transition:menu', {
            context: this,
            source: this,
            data: this._menu
        });
    }

    /**
     * Add the gadget to the applet.

     * ##### Events:
     * + 'add' - triggered after added. event.data => the added gadget.
     * + 'select' - triggered after new gadget selected. event.data => the selected gadget.
     *
     * @memberof TDIApplet#
     * @param {Gadget} gadget - The gadget to add.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {String} [options.title=gadget.title()] - A text to specify the caption displayed in the tab.
     * @param {String} [options.icon] - A text to specify the icon displayed in the tab.
     * @param {String} [options.badge=gadget.badge()] - A text to specify the symbol displayed in the tab.
     * @param {Boolean} [options.closable=false] - A true value to display a close button in the tab.
     * @param {Boolean} [options.selected=true] - A false value to prevent the new tabpane from being selected.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @param {Integer} [options.index] - index at which the specified component is to be inserted.
     * @returns {TDIApplet} this
     */
    function add(gadget, options) {
        if(!(gadget instanceof Gadget)) {
            throw new UnsupportedTypeException({
                supportedTypes: ['Gadget'],
                type: typeof gadget
            });
        }

        options || (options = {});

        var defaults = {
            closable: false,
            selected: true,
            title: gadget.title(),
            badge: gadget.badge()
        };

        _.defaults(options, defaults);

        this._tabPanel.add(gadget, options);

        this.listenTo(gadget, 'transition', _.bind(onGadgeTransition, this));

        return this;
    }

    /**
     * @todo update the tab's content(title &amp; badge)
     * @param event
     */
    function onGadgeTransition(event) {
        var gadget = event.context;
    }

    /**
     * Remove the gadget from the applet.
     *
     * ##### Events:
     * + 'remove' - triggered after removed. event.data => the removed gadget.
     * + 'select' - triggered after new gadget selected. event.data => the selected gadget.
     *
     * @memberof TDIApplet#
     * @param {Gadget} gadget - The gadget to remove.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {TDIApplet} this
     */
    function remove(gadget, options) {
        options || (options = {});
        this._tabPanel.remove(gadget, options);
        this.stopListening(gadget);
        return this;
    }

    function badge(gadget, text) {
        if(text===undefined) return this._tabPanel.badge(gadget);
        this._tabPanel.badge(gadget, text);
    }

    /**
     * Remove all gadgets from the applet.
     *
     * ##### Events:
     * + 'remove' - triggered after removed.
     *
     * @memberof TDIApplet#
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {TDIApplet} this
     */
    function removeAll(options) {
        options || (options = {});
        _.each(this.gadgets(), function(gadget) {
            this.stopListening(gadget);
        }, this);
        this._tabPanel.removeAll(options);
        return this;
    }

    /**
     * Select the gadget to show.
     *
     * ##### Events:
     * + 'select' - triggered after selected. event.data => the selected gadget.
     *
     * @memberof TDIApplet#
     * @param {Gadget|Integer} gadget - The gadget(or index of the gadget) to show.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {TDIApplet} this
     */
    function select(gadget, options) {
        this._tabPanel.select(gadget, options);

        return this;
    }

    /**
     * Get the gadget.
     *
     * @memberof TDIApplet#
     * @param {Integer} index - The index of gadget. zero-based.
     * @returns {Gadget}
     */
    function get(index) {
        return this._tabPanel.get(index);
    }

    /**
     * Get the active gadget.
     *
     * @memberof TDIApplet#
     * @returns {Gadget}
     */
    function current() {
        return this._tabPanel.current();
    }

    /**
     * Get the # of gadgets.
     *
     * @memberof TDIApplet#
     * @returns {Integer}
     */
    function size() {
        return this._tabPanel.size();
    }

    /**
     * Get all gadgets.
     *
     * @memberof TDIApplet#
     * @returns {Integer}
     */
    function gadgets() {
        return this._tabPanel.components();
    }

    /**
     *
     * @param gadget
     *
     * @todo trigger a event when a gadget bring to front (focus).
     */
    function bringToFront(gadget) {
        if(this._activeGadget) this.listenTo(this._activeGadget, 'focus', _.bind(onGadgetFocus, this));
        this.stopListening(gadget, 'focus');
        this._activeGadget = gadget;
        if(gadget.css('z-index')==this._maxZIndex) return;
        gadget.css('z-index', ++this._maxZIndex);
    }

    function onGadgetFocus(event) {
        var gadget = event.context;

        this.bringToFront(gadget);
    }

    var props = {
        _singleton: false,
        _menu: undefined,
        _title: undefined,
        _tabPanel: undefined,
        _maxZIndex: 0,
        _gadgets: undefined,
        _activeGadget: undefined,
        className: "container-fluid"
    };

    var TDIApplet = declare(Base, {
        initialize: initialize,
        render: render,
        menu: menu,
        isSingleton: isSingleton,
        start: start,
        stop: stop,
        pid: pid,
        title: title,
        badge: badge,
        add: add,
        remove: remove,
        removeAll: removeAll,
        select: select,
        get: get,
        current: current,
        size: size,
        gadgets: gadgets
    }, props);

    return TDIApplet;
});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
